## qdmr 0.10.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(qdmr VERSION 0.10.1)

set(RELEASE_SUFFIX "")

option(BUILD_TESTS "Build test programs" OFF)
option(BUILD_DOCS  "Build API documentation" OFF)
option(BUILD_MAN   "Build man page for dmrconf" OFF)
option(INSTALL_UDEV_RULES "Install udev rules file." ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

find_package(Qt5Core REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5UiTools REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5SerialPort REQUIRED)
find_package(Qt5Positioning REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(LIBUSB_1 REQUIRED)
find_package(YAMLCPP REQUIRED)

if (${BUILD_MAN})
  find_program(XSLTPROC_EXECUTABLE xsltproc DOC "xsltproc for man-page generation." REQUIRED)
endif(${BUILD_MAN})

if (${BUILD_DOCS})
  find_package(Doxygen REQUIRED dot)
endif(${BUILD_DOCS})

if (${BUILD_TESTS})
  find_package(Qt5Test REQUIRED)
endif(${BUILD_TESTS})

ADD_DEFINITIONS(${Qt5Widgets_DEFINITIONS})
#add_definitions("-DQT_EVENT_DISPATCHER_CORE_FOUNDATION=1")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

INCLUDE_DIRECTORIES(${Qt5Core_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5UiTools_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Network_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5SerialPort_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Positioning_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Test_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${LIBUSB_1_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${YAMLCPP_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/lib)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/lib)

LINK_DIRECTORIES(${PROJECT_BINARY_DIR}/src)

set(CORE_LIBS ${Qt5Core_LIBRARIES} ${Qt5Core_QTMAIN_LIBRARIES} ${Qt5Network_LIBRARIES}
  ${Qt5Positioning_LIBRARIES} ${Qt5SerialPort_LIBRARIES} ${LIBUSB_1_LIBRARIES}
  ${YAMLCPP_LIBRARIES})
set(LIBS ${CORE_LIBS} ${Qt5Widgets_LIBRARIES} ${Qt5UiTools_LIBRARIES})

IF (UNIX AND APPLE)
 SET(CORE_LIBS ${CORE_LIBS} "-framework IOKit -framework CoreFoundation")
ENDIF(UNIX AND APPLE)

set(PROJECT_VERSION_STRING "\"${PROJECT_VERSION}\"")
message(STATUS "Build version ${PROJECT_VERSION}")

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} -Wall -Wsign-compare")
set(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG}  -O0 -ggdb -fstack-protector -Wextra")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")


# Get default install directories under Linux
IF(UNIX AND NOT APPLE)
 INCLUDE(GNUInstallDirs)
ENDIF(UNIX AND NOT APPLE)
IF(UNIX AND APPLE)
 SET(CMAKE_INSTALL_LIBDIR "lib")
 SET(CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 SET(CMAKE_INSTALL_INCLUDEDIR "include")
 SET(CMAKE_INSTALL_FULL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
 # Set RPATH under MacOS
 SET(CMAKE_SKIP_RPATH FALSE)
 SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
 SET(CMAKE_SKIP_INSTALL_RPATH FALSE)
 SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 message(STATUS "RPATH: ${CMAKE_INSTALL_RPATH}")
ENDIF(UNIX AND APPLE)

# Sources...
add_subdirectory(lib)
add_subdirectory(cli)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(dist)

if(BUILD_TESTS)
 enable_testing()
 add_subdirectory(test)
endif(BUILD_TESTS)

# Source distribution packages:
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${PROJECT_VERSION}${RELEASE_SUFFIX}")
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/doc/html;/doc/latex;/doc/reveng;/doc/dmr-intro;/examples/*.dfu;/.git/;~$;.qm;*.user$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

=== dist/CMakeLists.txt ===
if (UNIX AND NOT APPLE)
  configure_file("qdmr.desktop.in" "qdmr.desktop")
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qdmr.desktop DESTINATION share/applications/)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr32.png DESTINATION share/icons/hicolor/32x32/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr48.png DESTINATION share/icons/hicolor/48x48/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr64.png DESTINATION share/icons/hicolor/64x64/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr72.png DESTINATION share/icons/hicolor/72x72/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr96.png DESTINATION share/icons/hicolor/96x96/ RENAME qdmr.png)
endif(UNIX AND NOT APPLE)

=== doc/CMakeLists.txt ===
#
# man-page generation
#
message(STATUS "Using xsltproc: ${XSLTPROC_EXECUTABLE}")
configure_file("dmrconf.in.xml" "dmrconf.xml")

if(UNIX AND NOT APPLE)
  set(DOCBOOK2MAN_XSLT ${CMAKE_CURRENT_SOURCE_DIR}/docbook_man.debian.xsl)
elseif(UNIX AND APPLE)
  set(DOCBOOK2MAN_XSLT ${CMAKE_CURRENT_SOURCE_DIR}/docbook_man.macports.xsl)
endif(UNIX AND NOT APPLE)

add_custom_command(
  OUTPUT dmrconf.1
  COMMAND ${XSLTPROC_EXECUTABLE}
          -o ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
          ${DOCBOOK2MAN_XSLT}
          ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating man-page for dmrconf."
  VERBATIM)

if (${BUILD_MAN})
  # Create man page from docbook
  add_custom_target(manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1)
  # install man page on unix systems
  if (UNIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
      DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1/)
  endif (UNIX)
endif(${BUILD_MAN})

#
# optional API docs
#
if (${BUILD_DOCS})
  set(DOXYGEN_PROJECT_NAME "libdrmconf")
  set(DOXYGEN_PROJECT_BRIEF "A library to program DMR radios.")
  set(DOXYGEN_BRIEF_MEMBER_DESC YES)
  set(DOXYGEN_JAVADOC_AUTOBRIEF YES)
  set(DOXYGEN_EXAMPLE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/code")
  set(DOXYGEN_DOTFILE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  set(DOXYGEN_ENABLE_PREPROCESSING YES)
  set(DOXYGEN_MACRO_EXPANSION YES)
  set(DOXYGEN_EXPAND_ONLY_PREDEF YES)
  set(DOXYGEN_PREDEFINED __attribute__(x) =)
  set(DOXYGEN_IMAGE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  doxygen_add_docs(apidocs
    ALL
    ${CMAKE_SOURCE_DIR}/lib
    COMMENT "Build API documentation")
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
          DESTINATION ${CMAKE_INSTALL_DOCDIR}/libdmrconf/)
endif(${BUILD_DOCS})

=== lib/CMakeLists.txt ===
IF (APPLE)
 SET(hid_SOURCES hid_macos.cc)
 SET(hid_HEADERS hid_macos.hh)
 #SET(hid_SOURCES hid_libusb.cc)
 #SET(hid_HEADERS hid_libusb.hh)
ELSE (APPLE)
 SET(hid_SOURCES hid_libusb.cc)
 SET(hid_HEADERS hid_libusb.hh)
ENDIF(APPLE)

SET(libdmrconf_SOURCES
    utils.cc crc32.cc signaling.cc codeplugcontext.cc addressmap.cc radiointerface.cc errorstack.cc
    usbdevice.cc radio.cc ${hid_SOURCES} dfu_libusb.cc usbserial.cc radioinfo.cc
    csvreader.cc dfufile.cc repeaterdatabase.cc userdatabase.cc logger.cc
    configobject.cc configreference.cc config.cc radiosettings.cc contact.cc rxgrouplist.cc channel.cc zone.cc
    scanlist.cc gpssystem.cc codeplug.cc roaming.cc callsigndb.cc talkgroupdatabase.cc radioid.cc
    tyt_radio.cc tyt_interface.cc tyt_codeplug.cc tyt_callsigndb.cc tyt_extensions.cc
    md2017.cc md2017_codeplug.cc md2017_callsigndb.cc md2017_filereader.cc
    md390.cc md390_codeplug.cc md390_filereader.cc
    uv390.cc uv390_codeplug.cc uv390_callsigndb.cc uv390_filereader.cc
    dm1701.cc dm1701_codeplug.cc dm1701_filereader.cc
    radioddity_radio.cc radioddity_codeplug.cc radioddity_extensions.cc radioddity_interface.cc
    rd5r.cc rd5r_codeplug.cc rd5r_filereader.cc
    gd77.cc gd77_codeplug.cc gd77_callsigndb.cc gd77_filereader.cc
    opengd77.cc opengd77_interface.cc opengd77_codeplug.cc opengd77_extension.cc opengd77_callsigndb.cc
    anytone_interface.cc anytone_radio.cc anytone_codeplug.cc
    d868uv.cc d868uv_codeplug.cc d868uv_callsigndb.cc
    d878uv.cc d878uv_codeplug.cc
    d578uv.cc d578uv_codeplug.cc
    d878uv2.cc d878uv2_codeplug.cc d878uv2_callsigndb.cc)
SET(libdmrconf_MOC_HEADERS
    usbdevice.hh radio.hh ${hid_HEADERS} dfu_libusb.hh usbserial.hh
    csvreader.hh dfufile.hh repeaterdatabase.hh userdatabase.hh logger.hh
    configobject.hh configreference.hh config.hh radiosettings.hh contact.hh rxgrouplist.hh channel.hh zone.hh
    scanlist.hh gpssystem.hh codeplug.hh roaming.hh callsigndb.hh talkgroupdatabase.hh radioid.hh
    tyt_radio.hh tyt_interface.hh tyt_codeplug.hh tyt_callsigndb.hh tyt_extensions.hh
    md2017.hh md2017_codeplug.hh md2017_callsigndb.hh
    md390.hh md390_codeplug.hh
    uv390.hh uv390_codeplug.hh uv390_callsigndb.hh
    dm1701.hh dm1701_codeplug.hh dm1701_filereader.hh
    radioddity_radio.hh radioddity_codeplug.hh radioddity_extensions.hh radioddity_interface.hh
    rd5r.hh rd5r_codeplug.hh
    gd77.hh gd77_codeplug.hh gd77_callsigndb.hh
    opengd77.hh opengd77_interface.hh opengd77_codeplug.hh opengd77_extension.hh opengd77_callsigndb.hh
    anytone_interface.hh anytone_radio.hh anytone_codeplug.hh
    d868uv.hh d868uv_codeplug.hh d868uv_callsigndb.hh
    d878uv.hh d878uv_codeplug.hh
    d578uv.hh d578uv_codeplug.hh
    d878uv2.hh d878uv2_codeplug.hh d878uv2_callsigndb.hh)
SET(libdmrconf_HEADERS libdmrconf.hh radiointerface.hh radioinfo.hh
    gd77_filereader.hh rd5r_filereader.hh uv390_filereader.hh md2017_filereader.hh
    md390_filereader.hh
    utils.hh crc32.hh signaling.hh codeplugcontext.hh addressmap.hh errorstack.hh)

configure_file(config.h.in ${PROJECT_BINARY_DIR}/lib/config.h)

#SET(CMAKE_AUTOMOC ON)
qt5_wrap_cpp(libdmrconf_MOC_SOURCES ${libdmrconf_MOC_HEADERS})

add_library(libdmrconf SHARED ${libdmrconf_SOURCES} ${libdmrconf_MOC_SOURCES})
set_target_properties(libdmrconf PROPERTIES
	MACOSX_RPATH TRUE
  OUTPUT_NAME dmrconf
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
target_link_libraries(libdmrconf ${CORE_LIBS})

install(TARGETS libdmrconf DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
install(FILES ${libdmrconf_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${libdmrconf_MOC_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${PROJECT_BINARY_DIR}/lib/config.h DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)

if (UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})
  install(FILES "${CMAKE_SOURCE_DIR}/dist/99-qdmr.rules" DESTINATION "/etc/udev/rules.d/")
endif(UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})

=== src/CMakeLists.txt ===
SET(qdmr_SOURCES main.cc
  configitemwrapper.cc
  application.cc settings.cc dmrcontactdialog.cc dtmfcontactdialog.cc rxgrouplistdialog.cc
	analogchanneldialog.cc digitalchanneldialog.cc channelvalidator.cc channelcombobox.cc
  channelselectiondialog.cc zonedialog.cc scanlistdialog.cc
  ctcssbox.cc verifydialog.cc gpssystemdialog.cc contactselectiondialog.cc
  aprssystemdialog.cc releasenotes.cc roamingzonedialog.cc searchpopup.cc
  configobjectlistview.cc configobjecttableview.cc
  generalsettingsview.cc radioidlistview.cc contactlistview.cc grouplistsview.cc channellistview.cc
  zonelistview.cc scanlistsview.cc positioningsystemlistview.cc roamingzonelistview.cc
  collapsablewidget.cc extensionview.cc extensionwrapper.cc propertydelegate.cc errormessageview.cc
  deviceselectiondialog.cc radioselectiondialog.cc dmriddialog.cc)
SET(qdmr_MOC_HEADERS
  configitemwrapper.hh
  application.hh settings.hh dmrcontactdialog.hh dtmfcontactdialog.hh rxgrouplistdialog.hh
	analogchanneldialog.hh digitalchanneldialog.hh channelvalidator.hh channelcombobox.hh
  channelselectiondialog.hh zonedialog.hh scanlistdialog.hh
  ctcssbox.hh verifydialog.hh gpssystemdialog.hh contactselectiondialog.hh
  aprssystemdialog.hh releasenotes.hh roamingzonedialog.hh searchpopup.hh
  configobjectlistview.hh configobjecttableview.hh
  generalsettingsview.hh radioidlistview.hh contactlistview.hh grouplistsview.hh channellistview.hh
  zonelistview.hh scanlistsview.hh positioningsystemlistview.hh roamingzonelistview.hh
  collapsablewidget.hh extensionview.hh extensionwrapper.hh propertydelegate.hh errormessageview.hh
  deviceselectiondialog.hh radioselectiondialog.hh dmriddialog.hh)
SET(qdmr_HEADERS )
SET(qdmr_UI_FORMS dmrcontactdialog.ui dtmfcontactdialog.ui rxgrouplistdialog.ui analogchanneldialog.ui zonedialog.ui
  digitalchanneldialog.ui scanlistdialog.ui configwizardstart.ui verifydialog.ui settingsdialog.ui
  gpssystemdialog.ui aprssystemdialog.ui roamingzonedialog.ui
  configobjectlistview.ui configobjecttableview.ui
  generalsettingsview.ui radioidlistview.ui contactlistview.ui grouplistsview.ui channellistview.ui
  zonelistview.ui scanlistsview.ui positioningsystemlistview.ui roamingzonelistview.ui
  errormessageview.ui extensionview.ui
  deviceselectiondialog.ui radioselectiondialog.ui dmriddialog.ui)

qt5_wrap_cpp(qdmr_MOC_SOURCES ${qdmr_MOC_HEADERS})
qt5_wrap_ui(qdmr_UI_SOURCES ${qdmr_UI_FORMS})
qt5_add_resources(qdmr_RCC_SOURCES ../shared/resources.qrc)

add_executable(qdmr WIN32 ${qdmr_SOURCES} ${qdmr_MOC_SOURCES} ${qdmr_RCC_SOURCES} ${qdmr_UI_SOURCES})
target_link_libraries(qdmr ${LIBS} libdmrconf)
target_include_directories(qdmr PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")
install(TARGETS qdmr DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== test/CMakeLists.txt ===
qt5_add_resources(testlib_RCC_SOURCES resources.qrc)

qt5_wrap_cpp(configtest_MOC_SOURCES configtest.hh)
add_executable(configtest configtest.cc ${configtest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(configtest ${LIBS} libdmrconf)

qt5_wrap_cpp(crc32test_MOC_SOURCES crc32test.hh)
add_executable(crc32test crc32test.cc ${crc32test_MOC_SOURCES})
target_link_libraries(crc32test ${LIBS} libdmrconf)

qt5_wrap_cpp(utilstest_MOC_SOURCES utilstest.hh)
add_executable(utilstest utilstest.cc ${utilstest_MOC_SOURCES})
target_link_libraries(utilstest ${LIBS} libdmrconf)

qt5_wrap_cpp(rd5rtest_MOC_SOURCES rd5rtest.hh)
add_executable(rd5rtest rd5rtest.cc ${rd5rtest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(rd5rtest ${LIBS} libdmrconf)

qt5_wrap_cpp(uv390test_MOC_SOURCES uv390test.hh)
add_executable(uv390test uv390test.cc ${uv390test_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(uv390test ${LIBS} libdmrconf)

add_test(NAME Config COMMAND configtest)
add_test(NAME CRC32  COMMAND crc32test)
add_test(NAME Utils  COMMAND utilstest)
add_test(NAME RD5R   COMMAND rd5rtest)
add_test(NAME UV390  COMMAND uv390test)

=== doc/manual/Makefile ===
SRC = manual.xml $(shell find meta/ -name "*.*") $(shell find intro/ -name "*.*") $(shell find gui/ -name "*.*")\
      $(shell find codeplug/ -name "*.*") $(shell find conf/ -name "*.*") $(shell find cli/ -name "*.*") 

all: images manual.pdf manual.epub html 

images:
	make -C intro/fig
	make -C gui/fig
	
	
manual.pdf: manual.fo
	fop -fo manual.fo -pdf manual.pdf
manual.fo: manual_combined.xml manual_fo.debian.xsl
	xsltproc -o manual.fo manual_fo.debian.xsl manual_combined.xml
manual_combined.xml: $(SRC) 
	xmllint --nonet --noent --xinclude manual.xml > manual_combined.xml


manual.epub: images-epub manual_combined.xml 
	cp manual_combined.xml epub/manual.xml 
	make -C epub 
images-epub: images epub/fig
	install intro/fig/*.png epub/fig 
	install gui/fig/*.png epub/fig 
epub/fig:
	mkdir epub/fig 


html: images-html
	cp manual_combined.xml html/manual.xml 
	make -C html 
images-html: images html/fig manual_combined.xml
	install intro/fig/*.png html/fig 
	install gui/fig/*.png html/fig 
html/fig:
	mkdir html/fig


clean: 
	make -C intro/fig clean
	make -C epub clean
	make -C html clean
	rm -f manual.pdf manual.fo manual_combined.xml

=== debian/changelog ===
qdmr (0.10.1-2) unstable; urgency=medium

  * Fixed copyright for icons.
  * Hopefully fixed build issues under ppc64, etc.

 -- Hannes Matuschek <dm3mat@darc.de>  Thu, 27 Jan 2022 13:14:02 +0100

qdmr (0.10.1-1) unstable; urgency=medium

  * Added auto-gen list of supported devices to about dialog.
  * Added access right check for Unix systems.
  * Implemented interface selection and detection.
  * Implemented Radioddity radio settings extension.
  * Implemented RadioID editor. Fixed RadioID list.
  * Store header states for all extension views.
  * Fixed stupid cast mistake in AbstractConfigObjectList.
  * Fixed encoding/decoding of APRS src/dst for D878UV and later.
  * Added color output for logger.
  * Fixed squelch encoding for RD5R.
  * Fixed decoding of AnyTone general settings.
  * Fixed manual license.

 -- Hannes Matuschek <dm3mat@darc.de>  Sat, 22 Jan 2022 17:05:20 +0100

qdmr (0.10.0-1) unstable; urgency=medium

  * Added support for Baofeng DM-1701, still untested and user-db is missing.
  * Hide extensions in AnalogChannelEditor if show-commercial-features is 
    disabled.
  * Fixed potential crash and memory leak in DTMFContactDialog.
  * Fixed squelch settings for RD-5R.
  * Implemented TyT menu, extension.
  * Fixed error message on TyT device detection.
  * Fixed copying of squelch settings & signalling for analog channels.
  * Fixed GUI update for general settings tab.
  * Fixed handling and instantiation of device specific extensions.

 -- Hannes Matuschek <dm3mat@darc.de>  Thu, 06 Jan 2022 12:11:11 +0100

qdmr (0.9.3-1) unstable; urgency=medium

  * Fixed YAML serialization.
  * Fixed YAML parser warning.
  * Added description fields for device specific settings.
  * Added TyT channel, scan list, general settings.
  * Fixed reset of owned ConfigItem properties.
  * Added auto-copying of properties.
  * Fixed udev rules (prep Debian package).
  * Fixed icon sizes (prep Debian package).

 -- Hannes Matuschek <dm3mat@darc.de>  Sun, 28 Nov 2021 13:55:26 +0100

qdmr (0.9.2-1) unstable; urgency=medium

  * Fixed YAML parser to properly link APRS systems. Fixes #179.
  * Fixed YAML parser issue serializing DefaultRadioID.
  * Fixed connection issue with TyT devices.
  * Fixed GUI update issue when reading a codeplug from the device.
  * Added extension editors to all config elements. These editors are only 
    visible when "Show Commercial Features" is enabled in the settings dialog.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Fri, 19 Nov 2021 22:52:48 +0100

qdmr (0.9.1-1) unstable; urgency=medium

  * Rewrite of codeplug representation, allows to extend generic device-
    independent codeplug representation for device specific settings.
  * New codeplug file format (YAML based). Also allows for device-specific 
    settings to be strored.
  * Rewrite of binary codeplug encoding/decoding. Allows to extend existing 
    codeplugs and codeplug elements by just implementing the differences. This
    makes the cumbersome encoding/decoding of device specific settings 
    feasible.
  * Added support for the TyT MD-2017.
  * Added TyT MD-390 support.
  * Added Hide/Show Commercial Features flag to settings dialog. This 
    shows/hides the radio ID list (in ham radio you will only need one DMR ID).
  * Cleanup of GUI. Some minor GUI cleanup things.
  * Added unified device names and --list-radios option for command line tool.
  * Fixed call-sign DB entry for OpenGD77.
  * Added band information to repeater database, showing it in auto-completer.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Sat, 06 Nov 2021 15:09:01 +0100

qdmr (0.9.0-alpha4-1) unstable; urgency=medium

  * Destroy radio object when verification fails.
  * Fixed ZoneDialog adding channels always to list A.
  * Fixed include path for yaml-cpp.
  * Fixed crash when encoding OpenGD77 codeplugs with extension.
  * Disabled conf-format export in command line tool.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Thu, 28 Oct 2021 16:19:57 +0200

qdmr (0.9.0-alpha3-1) unstable; urgency=medium

  * Added TyT MD-390 support.
  * Added alias for TyT MD-UV380 to UV390. 
  * Fixed crash after codeplug reset in the presence of extensions. 
  * Fixed encoding of GPS systems for TyT devices.
  * Fixed crash when decoding an unkown enum value. 
  * Fixed analog and digital channel dialog. 
  * Fixed copy constructor of Analog/DigitalChannel.
  * Fixed crash in TyTInterface when no radio is connected.
  * Fixed overriding of radio detection.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Sun, 10 Oct 2021 14:58:54 +0200

qdmr (0.9.0-alpha2-1) unstable; urgency=medium

  * Added unified device names and --list-radios option for command line tool
  * Cleanup & fixed decoding of UV390 and MD2017 codeplugs.
  * Fixed YAML serializer, added missing default DMR radio ID.
  * Added error message on call-sign DB upload when no default ID is specified.
  * Added find_library() for libyaml-cpp.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Mon, 04 Oct 2021 18:47:39 +0200

qdmr (0.9.0-alpha1-1) unstable; urgency=medium


  * Fixed encoding of admit criterion for AnyTone devices. Fixes #139.
  * Fixed YAML parser/serializer to handle unsigned ints again. Fixes #140.
  * Fixed squelch mode settings for AnyTone devices.
  * Fixed VOX enable/disable for channels in Radioddity & TyT codeplugs.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Sat, 02 Oct 2021 23:58:45 +0200

qdmr (0.9.0-alpha-1) unstable; urgency=medium

  * Reworked core library libdmrconf. 
  * Added Support for TyT MD-2017.
  * Unified GUI lists.

 -- Hannes Matuschek <hmatuschek@gmail.com>  Sat, 02 Oct 2021 14:54:30 +0200

qdmr (0.8.1-1) unstable; urgency=medium

  * Fixed support for Radioddity GD-77
  * Updated man page for command line tool.
  * Fixed CTCSS tone of 71.9Hz.
  * Fixed time-slot override for OpenGD77 firmware.
  * Fixed crash on transfer errors with OpenGD77 radios.
  * Added prefix selection for call-sign DB upload.



=== debian/control ===
Source: qdmr
Priority: optional
Maintainer: Hannes Matuschek <dm3mat@darc.de>
Build-Depends: debhelper (>= 11), cmake, xsltproc, docbook-xsl, qtbase5-dev, qttools5-dev, qttools5-dev-tools, qtpositioning5-dev, libqt5serialport5-dev, libusb-1.0-0-dev, libyaml-cpp-dev (>= 0.6.2)
Standards-Version: 4.5.1
Section: hamradio
Vcs-Browser: https://salsa.debian.org/dm3mat/qdmr
Vcs-Git: https://salsa.debian.org/dm3mat/qdmr.git
Homepage: https://dm3mat.darc.de/qdmr

Package: libdmrconf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdmrconf0.10 (= ${binary:Version}), ${misc:Depends}
Description: Header files for libdmrconf
 Libdmrconf is a Qt5 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the 
 OpenGD77 firmware. This package contains the header files for libdrmconf.

Package: libdmrconf0.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to program DMR radios
 Libdmrconf is a Qt5 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the 
 OpenGD77 firmware.

Package: qdmr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI application to program DMR radios
 qdmr is a Qt5 application to program DMR radios. DMR is a digital modulation
 standard used in amateur and commercial radio. To this end, qdmr is an 
 alternative codeplug programming software (CPS) that supports several radios 
 of several manufacturers. Including AnyTone AT-D868UVE, AT-D878UV, AT-878UVII, 
 AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, RT3S, RT82, 
 Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the OpenGD77 
 firmware.

## qdmr 0.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.0.0)
-project(qdmr VERSION 0.10.1)
+project(qdmr VERSION 0.10.2)
 
 set(RELEASE_SUFFIX "")

=== lib/CMakeLists.txt ===
IF (APPLE)
 SET(hid_SOURCES hid_macos.cc)
 SET(hid_HEADERS hid_macos.hh)
 #SET(hid_SOURCES hid_libusb.cc)
 #SET(hid_HEADERS hid_libusb.hh)
ELSE (APPLE)
 SET(hid_SOURCES hid_libusb.cc)
 SET(hid_HEADERS hid_libusb.hh)
ENDIF(APPLE)

SET(libdmrconf_SOURCES
    utils.cc crc32.cc signaling.cc codeplugcontext.cc addressmap.cc radiointerface.cc errorstack.cc
    radio.cc ${hid_SOURCES} dfu_libusb.cc usbserial.cc radioinfo.cc usbdevice.cc radiolimits.cc
    csvreader.cc dfufile.cc userdatabase.cc logger.cc
    configobject.cc configreference.cc config.cc radiosettings.cc contact.cc rxgrouplist.cc
    channel.cc zone.cc scanlist.cc gpssystem.cc codeplug.cc roaming.cc callsigndb.cc
    talkgroupdatabase.cc radioid.cc encryptionextension.cc commercial_extension.cc
    tyt_radio.cc tyt_interface.cc tyt_codeplug.cc tyt_callsigndb.cc tyt_extensions.cc
    md2017.cc md2017_codeplug.cc md2017_callsigndb.cc md2017_filereader.cc md2017_limits.cc
    md390.cc md390_codeplug.cc md390_filereader.cc md390_limits.cc
    uv390.cc uv390_codeplug.cc uv390_callsigndb.cc uv390_filereader.cc uv390_limits.cc
    dm1701.cc dm1701_codeplug.cc dm1701_filereader.cc dm1701_limits.cc
    radioddity_radio.cc radioddity_codeplug.cc radioddity_extensions.cc radioddity_interface.cc
    rd5r.cc rd5r_codeplug.cc rd5r_filereader.cc rd5r_limits.cc
    gd77.cc gd77_codeplug.cc gd77_callsigndb.cc gd77_filereader.cc gd77_limits.cc
    opengd77.cc opengd77_interface.cc opengd77_codeplug.cc opengd77_extension.cc
    opengd77_callsigndb.cc opengd77_limits.cc
    anytone_interface.cc anytone_radio.cc anytone_codeplug.cc anytone_extension.cc anytone_limits.cc
    d868uv.cc d868uv_codeplug.cc d868uv_callsigndb.cc d868uv_limits.cc
    d878uv.cc d878uv_codeplug.cc d878uv_limits.cc
    d578uv.cc d578uv_codeplug.cc d578uv_limits.cc
    d878uv2.cc d878uv2_codeplug.cc d878uv2_limits.cc d878uv2_callsigndb.cc)
SET(libdmrconf_MOC_HEADERS
    radio.hh ${hid_HEADERS} dfu_libusb.hh usbserial.hh radiolimits.hh
    csvreader.hh dfufile.hh userdatabase.hh logger.hh
    configobject.hh configreference.hh config.hh radiosettings.hh contact.hh rxgrouplist.hh
    channel.hh zone.hh scanlist.hh gpssystem.hh codeplug.hh roaming.hh callsigndb.hh
    talkgroupdatabase.hh radioid.hh encryptionextension.hh commercial_extension.hh
    tyt_radio.hh tyt_interface.hh tyt_codeplug.hh tyt_callsigndb.hh tyt_extensions.hh
    md2017.hh md2017_codeplug.hh md2017_callsigndb.hh md2017_limits.hh
    md390.hh md390_codeplug.hh md390_limits.hh
    uv390.hh uv390_codeplug.hh uv390_callsigndb.hh uv390_limits.hh
    dm1701.hh dm1701_codeplug.hh dm1701_filereader.hh dm1701_limits.hh
    radioddity_radio.hh radioddity_codeplug.hh radioddity_extensions.hh radioddity_interface.hh
    rd5r.hh rd5r_codeplug.hh rd5r_limits.hh
    gd77.hh gd77_codeplug.hh gd77_callsigndb.hh gd77_limits.hh
    opengd77.hh opengd77_interface.hh opengd77_codeplug.hh opengd77_extension.hh
    opengd77_callsigndb.hh opengd77_limits.hh
    anytone_interface.hh anytone_radio.hh anytone_codeplug.hh anytone_extension.hh anytone_limits.hh
    d868uv.hh d868uv_codeplug.hh d868uv_callsigndb.hh d868uv_limits.hh
    d878uv.hh d878uv_codeplug.hh d878uv_limits.hh
    d578uv.hh d578uv_codeplug.hh d578uv_limits.hh
    d878uv2.hh d878uv2_codeplug.hh d878uv2_limits.hh d878uv2_callsigndb.hh)
SET(libdmrconf_HEADERS libdmrconf.hh radiointerface.hh radioinfo.hh usbdevice.hh
    gd77_filereader.hh rd5r_filereader.hh uv390_filereader.hh md2017_filereader.hh
    md390_filereader.hh
    utils.hh crc32.hh signaling.hh codeplugcontext.hh addressmap.hh errorstack.hh)

configure_file(config.h.in ${PROJECT_BINARY_DIR}/lib/config.h)

#SET(CMAKE_AUTOMOC ON)
qt5_wrap_cpp(libdmrconf_MOC_SOURCES ${libdmrconf_MOC_HEADERS})

add_library(libdmrconf SHARED ${libdmrconf_SOURCES} ${libdmrconf_MOC_SOURCES})
set_target_properties(libdmrconf PROPERTIES
	MACOSX_RPATH TRUE
  OUTPUT_NAME dmrconf
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
target_link_libraries(libdmrconf ${CORE_LIBS})

install(TARGETS libdmrconf DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
install(FILES ${libdmrconf_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${libdmrconf_MOC_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${PROJECT_BINARY_DIR}/lib/config.h DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)

if (UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})
  install(FILES "${CMAKE_SOURCE_DIR}/dist/99-qdmr.rules" DESTINATION "/etc/udev/rules.d/")
endif(UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,8 @@
   generalsettingsview.cc radioidlistview.cc contactlistview.cc grouplistsview.cc channellistview.cc
   zonelistview.cc scanlistsview.cc positioningsystemlistview.cc roamingzonelistview.cc
   collapsablewidget.cc extensionview.cc extensionwrapper.cc propertydelegate.cc errormessageview.cc
-  deviceselectiondialog.cc radioselectiondialog.cc dmriddialog.cc)
+  deviceselectiondialog.cc radioselectiondialog.cc dmriddialog.cc configobjecttypeselectiondialog.cc
+  repeaterbookcompleter.cc)
 SET(qdmr_MOC_HEADERS
   configitemwrapper.hh
   application.hh settings.hh dmrcontactdialog.hh dtmfcontactdialog.hh rxgrouplistdialog.hh
@@ -21,7 +22,8 @@
   generalsettingsview.hh radioidlistview.hh contactlistview.hh grouplistsview.hh channellistview.hh
   zonelistview.hh scanlistsview.hh positioningsystemlistview.hh roamingzonelistview.hh
   collapsablewidget.hh extensionview.hh extensionwrapper.hh propertydelegate.hh errormessageview.hh
-  deviceselectiondialog.hh radioselectiondialog.hh dmriddialog.hh)
+  deviceselectiondialog.hh radioselectiondialog.hh dmriddialog.hh configobjecttypeselectiondialog.hh
+  repeaterbookcompleter.hh)
 SET(qdmr_HEADERS )
 SET(qdmr_UI_FORMS dmrcontactdialog.ui dtmfcontactdialog.ui rxgrouplistdialog.ui analogchanneldialog.ui zonedialog.ui
   digitalchanneldialog.ui scanlistdialog.ui configwizardstart.ui verifydialog.ui settingsdialog.ui
@@ -30,7 +32,7 @@
   generalsettingsview.ui radioidlistview.ui contactlistview.ui grouplistsview.ui channellistview.ui
   zonelistview.ui scanlistsview.ui positioningsystemlistview.ui roamingzonelistview.ui
   errormessageview.ui extensionview.ui
-  deviceselectiondialog.ui radioselectiondialog.ui dmriddialog.ui)
+  deviceselectiondialog.ui radioselectiondialog.ui dmriddialog.ui configobjecttypeselectiondialog.ui)
 
 qt5_wrap_cpp(qdmr_MOC_SOURCES ${qdmr_MOC_HEADERS})
 qt5_wrap_ui(qdmr_UI_SOURCES ${qdmr_UI_FORMS})

=== debian/changelog ===
qdmr (0.10.2-1) unstable; urgency=medium
  
  * Repeaterbook integration.
  * Implemented encryption settings.
  * Added 'show extension' setting.
  * Implemented bitmap for hidden zones for the AT-D878UV and later.
  * Fixed static colors for ChannelListView (dark mode).
  * Fixed limit DB entries toggling.
  * Fixed radio limit checks.
  * Fixed MD2017 zone decoding (off-by-one error).
  * Fixed creation of APRS channel when decoding D878UV codeplugs.
  * Fixed encoding/decoding of DCS settings for all AnyTone devices.

 -- Hannes Matuschek <dm3mat@darc.de>  Sat, 26 Mar 2022 13:00:02 +0100

## qdmr 0.11.0

=== debian/changelog ===
qdmr (0.11.0-1) unstable; urgency=medium
  
  * Implementation of BTECH DMR-6X2UV.
  * Added roaming channels.
  * Updated Brandmeister API.
  * Fixed crash when copying channels.
  * Fixed crash decoding MD2017 channels.
  * Fixed roaming zone edit dialog.
  * Fixed removal of B channels in zones.
  * Fixed crash in command line tool verification.

 -- Hannes Matuschek <dm3mat@darc.de>  Wed, 11 Jan 2023 15:41:00 +0100

qdmr (0.10.4-1) unstable; urgency=medium
  
  * Fixed handling of sparse lists for DM-1701, MD-2017, MD-390, MD-UV390.
  * Fixed encoding of TyT group lists.
  * Implemented DMR channel extension for AnyTone devices.
  * Fixed error message, when device detection fails.
  * Added notes about auto-completion to channel dialogs.
  * Added German translation.

 -- Hannes Matuschek <dm3mat@darc.de>  Fri, 21 Oct 2022 19:24:00 +0200

qdmr (0.10.3-1) unstable; urgency=medium
  
  * TyT: Fixed scan-list transmit-channel decoding.
  * MD380/MD390: Fixed handling of invalid frequency range.
  * DM-1701: Fixed detection.
  * MD-2017: Fixed decoding of contact elements.
  * AnyTone: Extended channel extension.
  * AnyTone: Fixed encoding/decoding for DTMF contacts.
  * AnyTone: Fixed frequency ranges.
  * AnyTone: Fixed decoding of alert type of contact elements.
  * AnyTone: Fixed encoding/decoding of contacts.
  * GD77: Fixed callsign db.
  * OpenGD77: Updated codeplug to FW rev E2022.02.
  * OpenGD77: Implemented scan flags for channels.
  * OpenGD77: Swapped time-slot override flags for contact extension.
  * OpenGD77: Fixed encoding of group lists for OpenGD77.
  * OpenGD77: Fixed encoding of contact extension.
  * Core: Fixed handling of private calls in group lists.
  * Core: Fixed crash when encoding a channel missing the default radio id.
  * Core: Skip TX frequency check if channel is RX only.
  * Core: Fixed reset of codeplugs.
  * GUI: Fixed swapped RX/TX frequencies in auto-completion.
  * GUI: Removed 'Refresh Repeater DB' menu entry. Useless since 0.10.2.

 -- Hannes Matuschek <dm3mat@darc.de>  Sun, 11 Sep 2022 16:31:00 +0200
